//********************************************************************
//  Reporter.java       Author: Ryo (Rio) Akasaka
//  
//  Last modified: Wed Feb 6, 2007 17:56
//
//  Description: Customer object that contains information about
//  each customer.
//
//********************************************************************

import java.util.Scanner;
public class Reporter
{  
  double total1 = 0.0;
  String served;
  double minutes = 0.0;
  int lost = 0;
  int numcustomers = 0;

  public void information(Queue report, String verbose, double probability, int maxclock)
  {
    while(!report.isEmpty()) {
      report.getfirst();
      int cnum = ((Customer) report.getfirst()).getinfo(0);
      int arrival = ((Customer) report.getfirst()).getinfo(1);
      int ttime = ((Customer) report.getfirst()).getinfo(3);
      int inq = ((Customer) report.getfirst()).getinfo(4);
      if (((Customer) report.getfirst()).getinfo(2) != 0) { served = "Yes"; numcustomers++; }
      else { served = "No "; lost++; }

      if(verbose.equalsIgnoreCase("y")) {
	System.out.println(cnum + "   " + arrival + "   " + served + "   " + inq + "   " + ttime);
      }
      report.dequeue();
	total1 = (inq + total1);
    }
    System.out.println("\nRunning the simulation for " + maxclock + " minutes, 2 pumps and");
    System.out.println(probability + " probablility that a passing car wants gas in");
    System.out.println("any given minute, we served " + numcustomers + " customers.");
    System.out.println("We lost " + lost + " customers.");
    System.out.println("Total queue time: " + total1);
    minutes = (total1/numcustomers);
    if (numcustomers != 0) System.out.println("So the average time waiting in line was " + minutes + " minutes per customer served.");
    else System.out.println("This simulation was too short for customers to be completely served.");
  }
    
  public String toString()
  { String result = "";
    return result;
  }
}
