//********************************************************************
//  Pump.java       Author: Ryo (Rio) Akasaka
//  
//  Last modified: Wed Feb 6, 2007 17:56
//
//  Description: Pump class that checks whether or not the customer
//  currently at the pump is done. Also checks to see if the pump
//  is occupied.
//
//********************************************************************

public class Pump
{  
  private int totaltime = 0, inq = 0;
 
  // Check status
  public Boolean occupied(Queue queue)
  {
    if (queue.isEmpty()) return false;
    else return true;
  }

  public void servicing(Queue queue, int clock, int pumpnum, Queue report, String verbose)
  {
    // Checks if first customer is done
    if ((((Customer) queue.getfirst()).getinfo(3)) == clock) 
      {
       // Send the first customer in line the report.
	report.enqueue(queue.getfirst());
	((Customer) queue.getfirst()).totaltime(clock);
	totaltime = ((Customer) queue.getfirst()).getinfo(3);
	inq = ((Customer) queue.getfirst()).getinfo(4);
	if(verbose.equalsIgnoreCase("t")) System.out.print(" Customer at pump "+ pumpnum + " is done with a total time of " + totaltime + " and an in-queue time of "+ inq + ".\n");
	queue.dequeue();
	if (queue.size() != 0)
	  {
	    ((Customer) queue.getfirst()).servtime(clock);
	  }
      }
  }
}